require "msise90"
require "numru/dcl"

################################################################
def get_profile(iyd,glat,glong,stl, 
		zstr = 70.0, zend = 200.0,
		f107a=135.0, f107=135.0, ap=8.0, mass=48)

   sec = 3600*(stl-glong/15)

   profile = Hash.new

   dz = 1.0
   nlev = ((zend-zstr)/dz).round + 1

   z = Array.new
   first = true
   for lv in 0..nlev-1
      alt = zstr + dz*lv
      z.push(alt)
      reslt = Msise90.gtd6_(iyd,sec,alt,glat,glong,stl,f107a,f107,ap,mass)
      if first
	 reslt.each do |k,v|
	    profile[k]=NArray.float(nlev)
	 end
	 first = false
      end
      reslt.each do |k,v|
	 profile[k][lv] = v
      end
   end
   [z, profile]
end
################################################################

iyd = 2002001
glat = 35.0
glong = 135.0
stl = 12.0

z, profile = get_profile(iyd,glat,glong,stl)

#p profile

include NumRu
DCL.gropn(1)
DCL.gllset('lmiss', true)
DCL.glrset('rmiss', 0.0)
DCL.grfrm
DCL.grstrn(3)
DCL.grsvpt(0.2, 0.8, 0.2, 0.8)
DCL.grswnd(1e7, 1e15, z.min, z.max)
DCL.grstrf
DCL.ussttl('number density','cm-3','altitude','km')
DCL.usdaxs
DCL.sglset('lchar',true)
DCL.sgsplc("O") 
DCL.sgplu(profile["O"],z)
DCL.sgsplc("O2") 
DCL.sgplzu(profile["O2"],z,2,1)
DCL.sgsplc("N2") 
DCL.sgplzu(profile["N2"],z,3,1)
DCL.sglset('lchar',false)

DCL.grfrm
DCL.ussttl('temperature','K','altitude','km')
DCL.usgrph(profile["T"],z)

DCL.grcls
